










                            Pas-Ed (TM) version 1.0
                        Programmer's Editor for Pascal


                               Ŀ
                                USER'S MANUAL 
                               


                       Copyright (C) 1989 by Hedco, Inc.
                             All rights reserved.

                                 October, 1989


                           


                                  Hedco, Inc.
                                 P.O. Box 606
                           Tehachapi, CA 93581   USA

                           Telephone: (805) 821-0167
                Monday through Friday, 9am to 5pm Pacific time

                           On CompuServe: 76137,1656





















Title Page                                                         Pas-Ed Manual






                           Copyrights and Trademarks
                           


Pas-Ed version 1.0 is copyrighted (C) 1989 by Hedco, Inc.

Pas-Ed and HEDCO are trademarks of Hedco, Inc.

Turbo Pascal, Turbo Debugger, Turbo Assembler, and Sidekick are registered
trademarks of Borland International, Inc.

TurboPower Software is a trademark of TurboPower Software, Inc.

WordStar is a registered trademark of WordStar International, Inc.

IBM is a registered trademark of International Business Machines Corporation.





Acknowledgments


The EMS/Disk swapping routine is based on the public domain unit EXECSWAP
written by Kim Kokkonen of TurboPower Software.


























Preface                                                   Pas-Ed Manual - Page i



                           Pas-Ed License Agreement
                           


DEFINITIONS


Hedco - Hedco, Inc.
Pas-Ed - The Pas-Ed software and documentation.


LICENSE


Pas-Ed is a copyrighted, proprietary program of Hedco.  A single-user limited
license is granted to you to use Pas-Ed for your personal use for a fifteen (15)
day trial period.  If you would like to purchase a single-user license to
continue to use Pas-Ed after the trial period, you may do so by making a $40
payment to Hedco at the address shown on the Title Page of this manual.  To
purchase a group license, contact Hedco for fees and instructions.  If you do
not purchase a license from Hedco to use Pas-Ed, you must discontinue use of
Pas-Ed after the 15 day trial period.


LIMITED, EXCLUSIVE WARRANTY


Hedco warrants that the software will perform substantially as described in the
documentation for a period of 30 days from the date of purchase.  Hedco makes no
other warranty or representation, either express or implied, with respect to the
software or its documentation, their quality, performance, merchantability, or
fitness for a particular purpose.  This Limited Warranty is void if the software
or documentation has been abused, misapplied, or altered.


LIABILITY DISCLAIMER AND REMEDIES


In no event will Hedco be liable for direct, indirect, special, incidental or
consequential damages arising out of the use or inability to use Pas-Ed even if
Hedco has been advised of the possibility of such damages, and the entire and
exclusive liability and remedy shall be to return Pas-Ed to Hedco within the
warranty period for replacement or refund.


GOVERNING LAW


This License Agreement shall be governed by the laws of the State of California,
and any action filed hereunder shall only be brought in Kern County, California.





Preface                                                  Pas-Ed Manual - Page ii




                               Table of Contents
                               



         Preface                                               Page  i
         Copyrights and Trademarks ............................      i
         Pas-Ed License Agreement .............................     ii


         Chapter 1   Introduction To Pas-Ed                    Page  1
         About This Manual ....................................      1
         About Pas-Ed .........................................      1
         System Requirements ..................................      2
         Contacting Hedco .....................................      3


         Chapter 2   Setting Up Pas-Ed                         Page  4
         Pas-Ed Files .........................................      4
         Getting Pas-Ed Ready .................................      4
         Starting Pas-Ed ......................................      5
         The Opening Screen ...................................      6
         Navigating The Menu System ...........................      6
         The Options Menu .....................................      7
         The Color Chart ......................................      9
         Setting Up The Macros ................................     10
         Setting Up Turbo Pascal ..............................     10
         Ready To Go ..........................................     11


         Chapter 3   A Tour Of Pas-Ed                          Page 12
         Getting Ready ........................................     12
         Restoring Your Setup .................................     12
         The Editor ...........................................     13
         The Window Menu ......................................     14
         The Search Menu ......................................     14
         The Macro Menu .......................................     15
         The Other Menus ......................................     16
         The Pop-up Tables ....................................     16


         Chapter 4   The Pas-Ed Menu System                    Page 17
         About The Menus ......................................     17
         The Menu Selections ..................................     17
         File Menu ............................................     17
         Window Menu ..........................................     18
         Edit Menu ............................................     19
         Search Menu ..........................................     20
         Macros Menu ..........................................     21





Table of Contents                                                  Pas-Ed Manual






         Chapter 4   The Pas-Ed Menu System (continued)
         Compile Menu .........................................     22
         Run Menu .............................................     23
         Debug Menu ...........................................     23
         Language Menu ........................................     23
         Options Menu .........................................     27


         Chapter 5   The Pas-Ed Editor                         Page 31
         About The Editor .....................................     31
         The Editor Message Line ..............................     31
         The Editor Status Line ...............................     32
         The Function Keys ....................................     32
         Entering Text ........................................     33


         Chapter 6   Hints On Using Pas-Ed                     Page 34



































Table of Contents                                                  Pas-Ed Manual




                      Chapter 1 - Introduction To Pas-Ed
                      



About This Manual


This manual is organized into six chapters:

     Chapter 1 - Introduction To Pas-Ed (this chapter)
     Chapter 2 - Setting Up Pas-Ed
     Chapter 3 - A Tour of Pas-Ed
     Chapter 4 - The Pas-Ed Menu System
     Chapter 5 - The Pas-Ed Editor
     Chapter 6 - Hints on Using Pas-Ed

It's assumed in this manual that you're familiar with Turbo Pascal and the Turbo
integrated development environment (IDE).  The Pas-Ed editor is identical to the
editor in the Turbo IDE.  This manual doesn't attempt to explain the intricacies
of Turbo Pascal or of WordStar-type editors.  These subjects are covered in
detail in the Turbo Pascal manuals, which you're assumed to have.

This manual strives to get you, the programmer, up and running with Pas-Ed in as
little time as possible.  This is accomplished via a hands-on, setup tutorial in
Chapter 2, Setting Up Pas-Ed.  Completing this tutorial should take about 15-20
minutes, by which time you should have Pas-Ed set up to your liking.

Users familiar with the Turbo IDE or Sidekick should have no trouble running
Pas-Ed at that point.  Those who would like a more complete introduction are
encouraged to read Chapter 3, A Tour of Pas-Ed, which steps you through some of
the more important features of Pas-Ed as they're explained.

We also recommend browsing through Chapter 6 - Hints on Using Pas-Ed.



About Pas-Ed


Pas-Ed is an ASCII file programmer's editor created to streamline the process of
editing, compiling, debugging, and running programs written in Turbo Pascal.
Since it's an ASCII file editor, Pas-Ed can also be used to edit programs for
other compilers, but it will be clear when you run Pas-Ed that it's main forte
is Turbo Pascal.  Pas-Ed's support for Turbo Pascal is unmatched by any other
programmer's editor.  Pas-Ed combines the ease of use of the Turbo IDE with
sophisticated multi-file and memory handling abilities.  Some of Pas-Ed's
features include:

     - An integrated development environment for ease of use.




Chapter 1 - Introduction To Pas-Ed                        Pas-Ed Manual - Page 1



     - Edit up to 21 files in a combination of DOS and EMS memory.

     - Windows that can be individually opened and closed, zoomed and unzoomed,
       hidden and unhidden, and recolored.

     - 43/50 line screen modes on EGA/VGA systems.

     - Direct menu support for all Turbo Pascal compiler and linker switches.

     - Automatic TPC.CFG compiler configuration file generation based on menu
       selections.

     - EMS or disk swapping during DOS shells and compile, debug and run
       sessions, which frees up all but 6.4k of DOS memory.

     - Automatic error locating including /F Find Error.

     - Debug programs from within Pas-Ed by using Turbo Debugger.

     - Automatic restoration of the previous setup at startup.

     - Keyboard macros with adjustable playback delay.

     - Inter-file block copy and move of text.

     - Find and replace using text from a marked block.

     - Jump to a specific file or line number.

     - 10 placemarkers that operate within and between files.

     - Pop-up ASCII character table (shows the ASCII character and its decimal,
       hex, and binary values, plus, if the ASCII value is under 32, the control
       code).

     - Pop-up extended key code table (shows the extended key codes of the
       function keys, <Alt> + keys, arrow keys, etc.).



System Requirements


Hedco recommends that you run Pas-Ed on a computer system with at least 512k of
DOS memory and a hard disk.  EMS memory is not required.  Pas-Ed will run on a
high-capacity floppy disk system, but you should realize that DOS memory swaps
will necessarily be slow if they must be made to disk.  Also, because Pas-Ed
leaves such a small kernel in memory, swap sizes will approach the amount of
free DOS memory as reported by CHKDSK.  This could be a problem on some floppy
disk systems.  In the following example, CHKDSK reports 451,328 bytes of free
memory, which gives a good approximation of the size of the swap file:




Chapter 1 - Introduction To Pas-Ed                        Pas-Ed Manual - Page 2



     A:\>chkdsk

        730112 bytes total disk space
         45056 bytes in 2 hidden files
        214016 bytes in 7 user files
        471040 bytes available on disk

        655360 bytes total memory
        451328 bytes free

In the above example, with only 471,040 bytes available on disk and a swap file
size of close to 451,328 bytes, there will be almost no room left on the disk
for the compiled program and/or for using a disk link buffer after the swap file
has been written to disk.  Systems with dual 720k floppy drives will necessarily
have to use both drives.  If you have a floppy disk system, no EMS memory, and
only one or two edit window open, try turning EMS/Disk swapping off during DOS
shells or when compiling very small programs.  Pas-Ed compresses the heap when
EMS/Disk swapping is disabled, and exec sessions requiring minimal amounts of
memory should operate without problem.  If you get insufficient memory messages,
turn EMS/Disk swapping back on.



Contacting Hedco


Pas-Ed is continually evolving to meet the needs of Pascal programmers.  As you
use Pas-Ed, you'll undoubtedly think of additional features which Pas-Ed should
have or changes that might enhance the program.  Please write Hedco with your
suggestions or comments.  Our address is:

     Hedco, Inc.
     P.O. Box 606
     Tehachapi, CA 93581
     USA

     Telephone: (805) 821-0167
                Monday through Friday, 9am to 5pm Pacific time

     On CompuServe: 76137,1656















Chapter 1 - Introduction To Pas-Ed                        Pas-Ed Manual - Page 3




                         Chapter 2 - Setting Up Pas-Ed
                         



Pas-Ed Files


If you haven't already done so, make backup copies of the Pas-Ed files.  The
complete Pas-Ed package includes the following files:

     PAS-ED.EXE    The Pas-Ed program.  This is the only file needed to run
                   Pas-Ed.

     PAS-ED.MAC    Sample macro file.

     PAS-ED.MAN    The complete, on-disk manual (this file).

     PAS-ED.CFG    The Pas-Ed configuration file.  This file is NOT included in
                   the Pas-Ed package, but is listed here for completeness.  It
                   is created by Pas-Ed every time you exit the program, and
                   contains data representing the state of Pas-Ed upon exit.
                   It's used to restore your last setup when you restart Pas-Ed.

By default, Pas-Ed uses the following programs from Borland International to
compile and debug Turbo Pascal programs, although any compiler or debugger can
be used:

     TPC.EXE       The Turbo Pascal compiler and library files.  These files are
     TURBO.TPL     used to compile your source code files.

     TD.EXE        Turbo Debugger.



Getting Pas-Ed Ready


Those unfamiliar with setting up directories and paths and copying files should
refer to your DOS or Turbo Pascal user's manuals.

The easiest way to set up Pas-Ed on your computer is to copy all the necessary
Pas-Ed, compiler, and debugger files into the same directory.  If this isn't
feasible, another method is to have the Pas-Ed, compiler, and debugger files in
different directories and use DOS' PATH command to tell DOS where to look for
them.  For example, if the compiler files were located on your hard disk drive C
in the directory \TP, the command would be:

     PATH = C:\TP





Chapter 2 - Setting Up Pas-Ed                             Pas-Ed Manual - Page 4



This command is best entered into your AUTOEXEC.BAT file, and you can specify
several paths separated by ";", such as:

     PATH = C:\TP;C:\TD;D:\PAS-ED



Starting Pas-Ed


With Pas-Ed in the current directory, type "Pas-Ed".  The program will load and
the Pas-Ed license menu will appear.  It will be necessary to accept the Pas-Ed
License Agreement for the program to continue.  The Pas-Ed License Agreement is
located in the preface of this manual.  This menu appears the first time Pas-Ed
is started, and thereafter the program is entered directly.

Since this is the first time the program has been run, there's no PAS-ED.CFG
configuration file for Pas-Ed to read to restore the prior setup.  A message to
this effect appears, which, if you had previously used Pas-Ed and had created a
configuration file, would alert you to possible corruption of that file so you
could recheck your configuration settings.  Press <Esc> to clear the message and
bring up the File Name window.

The File Name window is used whenever Pas-Ed needs the name of a file to edit,
load, save, write to, etc.  The operation of this window is explained in detail
in Chapter 3 - A Tour of Pas-Ed.  For now, press <Esc> to tell Pas-Ed you don't
want to open a particular file.  Pas-Ed has to have at least one window open
(after all, there's no point in using an editor if you don't want to edit any
files), so Pas-Ed opens the file NONAME.1.  If this file exists in the current
directory, Pas-Ed will open NONAME.2, and if NONAME.2 exists, Pas-Ed will open
NONAME.3, etc.  After opening the window, Pas-Ed presents you with the opening
screen.























Chapter 2 - Setting Up Pas-Ed                             Pas-Ed Manual - Page 5



The Opening Screen




   File  Window  Edit  Search  Macros  Compile  Run  Debug  Language  Options

Ŀ
                                                  
             Pas-Ed (TM) version 1.0              
          Programmer's Editor for Pascal          
        Copyright (C) 1989 by Hedco, Inc.         
               All rights reserved.               
                          
              Registration fee: $40               
                 Please send to:                  
                   Hedco, Inc.                    
                   P.O. Box 606                   
            Tehachapi, CA 93581   USA             
            Telephone: (805) 821-0167             
           (indicate 3" or 5" disks)            
                          
      Use of this software is subject to the      
            Pas-Ed License Agreement.             
  HEDCO and Pas-Ed are trademarks of Hedco, Inc.  
                                                  



1                Load/save files  DOS commands  Exit program               DOS




The opening screen contains Pas-Ed's copyright, trademark, and registration
information.  The top line of the screen is Pas-Ed's main menu, and the bottom
line is the status line, which contains prompt or status information.  Since
"File" is highlighted, the status line briefly explains the File selection.  The
"1" in the far left column of the status line indicates that the number 1 window
is active.  If you had two windows open and the second window was active, a "2"
would be displayed.  The "DOS" to the far right of the status line indicates
where the edit buffer has been allocated, in this case DOS memory.  If the
buffer had been allocated in EMS memory, "EMS" would appear here.



Navigating The Menu System


The menu system is navigated by using either the dedicated movement keys, such
as the arrow, Home, and End keys, or WordStar commands, such as <Ctrl-S> for




Chapter 2 - Setting Up Pas-Ed                             Pas-Ed Manual - Page 6



left, <Ctrl-D> for right, etc.  Pressing <Enter> when the light bar is over a
selection or pressing its highlighted letter selects it, and <Esc> deselects or
closes a menu.

Open the Options menu at this time by pressing <Alt-O>.  All the main menu
selections, such as File, Window, Edit, Search, etc., are "hot-keyed", meaning
they can be selected from anywhere in Pas-Ed, including from the editor, by
pressing the Alt key and the first letter of the selection.  For example, go
ahead and enter the editor now by pressing <Alt-E> and then reopen the Options
menu by pressing <Alt-O>.



The Options Menu


You will notice that, when you entered the editor, the opening screen was
cleared.  The opening screen appears only at startup.

At the top of the Options menu is "Config auto save."  If this selection is on,
the PAS-ED.CFG configuration file is saved to disk whenever you exit the
program.  This file allows Pas-Ed to restore your previous setup when you
restart the program.  It's a good idea to leave this option on unless you have
reason not to.

The next selection is "Edit file save."  This selection brings up a submenu with
the choices "Auto", "Prompt", and "Off."  These choices indicate how the file in
the active window will be saved.  If Auto is selected and the file has been
changed during the editing session, the file will automatically be saved prior
to a DOS shell or a debug or run session or before exiting the program.  Prompt
means you'll be prompted whether or not to save the file, and Off means the file
won't be saved and you won't be prompted.  After you've made a selection, a
submenu appears asking whether you want the change to be effective for just the
current window or for all windows.  Each window can have its own setting.
Pressing <Esc> cancels the change.

In most cases, Auto is the best choice, although Off is quite useful if you're
cutting and pasting from one of your library files and don't want any accidental
changes to the file to be saved (remember to reset this setting once you resume
normal editing in the window).

You may be wondering why changed files are saved prior to DOS shells and debug
and run sessions.  The reason is that these are the types of sessions where
there's a good chance of a system crash, such as when debugging or running a new
program with a fatal bug, thus losing all unsaved editing changes.

Next is "Backup file," which determines whether a ".BAK" file is created when
the current file is saved.  This option is usually best left on unless speed
and/or disk space are factors, and here too each window can have its own
setting.





Chapter 2 - Setting Up Pas-Ed                             Pas-Ed Manual - Page 7



Next is "Macro auto save," which determines whether the in-memory macros are
automatically saved to disk prior to exiting the program.  This option is also
usually best left on.

Now press <U> for "memory Usage," which opens the Memory Usage submenu that
determines how Pas-Ed will use the available DOS and EMS memory.  The first
selection on the submenu is "Swap to EMS/disk," which determines whether Pas-Ed
will swap a DOS memory image to EMS memory or disk prior to a DOS shell or a
compile, debug, or run session.  If enabled, a DOS memory swap is made and all
but 6.4k of DOS memory is freed up for the session.  If off, the heap is
compressed and a standard DOS exec session is initiated with whatever DOS memory
is available (the amount of available DOS memory depends on the number of
windows you've opened).

The second selection on the Memory Usage submenu, "Reserve EMS for swap,"
determines whether enough EMS memory will be reserved to hold a DOS memory swap.
If your system doesn't have EMS memory or if there's not enough EMS memory
available for the swap, then Pas-Ed will prevent you from enabling this option
and the reason for this will be displayed in a pop-up window.

The third selection on the Memory Usage submenu, "Working memory", allows you to
specify the amount of DOS memory, in bytes, that Pas-Ed sets aside for internal
program use.  The default is 16,384 bytes (16k), which is the minimum amount of
memory Pas-Ed will reserve.  This should prove sufficient for most situations.
This figure may have to be adjusted upward if your setup of Pas-Ed uses a
significant amount of working memory, such as if you've defined numerous macros
or are making large EMS-to-EMS block copies and moves, etc.  (Since only one
EMS-based file can be mapped into DOS memory at once, EMS-to-EMS block transfers
are temporarily stored in working memory.)  If you get insufficient memory
messages, raise the amount of working memory.

Press <Esc> to return to the Options menu, then <S> for "Screen colors."  The
Screen Colors submenu appears, displaying all the program color types.  An arrow
is displayed next to the Screen Colors submenu, showing which color type is
currently selected.  Use the arrow, Home, and End keys to choose a color type to
change, then press <Enter>.



















Chapter 2 - Setting Up Pas-Ed                             Pas-Ed Manual - Page 8



The Color Chart




   File  Window  Edit  Search  Macros  Compile  Run  Debug  Language  Options
Ŀ           ͻĿ
 Normal text color     <      New Value Ŀ      Old Value Ŀ   
 Highlighted text                           7                 7        
 Marked text block                           
 Text error message                   Color Chart Ŀ   
 Normal background                      0   1   2   3   4   5   6   7    
 Status line color                      8   9  10  11  12  13  14  15    
 Normal menu color                     16  17  18  19  20  21  22  23    
 Highlighted menu                      24  25  26  27  28  29  30  31    
 Selected menu item                    32  33  34  35  36  37  38  39    
 Menu border color                     40  41  42  43  44  45  46  47    
 Menu title color                      48  49  50  51  52  53  54  55   
 Normal message color                  56  57  58  59  60  61  62  63   
 Highlighted message                   64  65  66  67  68  69  70  71   
 Selected message item                 72  73  74  75  76  77  78  79   
 Message border color                  80  81  82  83  84  85  86  87   
 Message title color                   88  89  90  91  92  93  94  95   
 Normal help color                     96  97  98  99 100 101 102 103   
 Highlighted help                     104 105 106 107 108 109 110 111   
 Selected help item                   112 113 114 115 116 117 118 119   
 Help border color                    120 121 122 123 124 125 126 127   
 Help title color                      
           ͼ




The color chart appears showing all possible color combinations and their byte
values.  At the top of the color chart are two boxes showing the old and new
byte values of the selected color type.  Use the arrow, Home, and End keys to
change the color value, noticing that the change is reflected in both the new
color value box and the Screen Colors submenu.  The status line gives a brief
explanation of how the new color value is incremented or decremented depending
on which key is pressed. Pressing <Enter> selects the new color, while <Esc>
restores the old color.

When all the program color types are changed to your liking, press <Esc> to exit
the Screen Colors submenu.  The menu and message colors are changed immediately.
A submenu appears asking whether you want the color changes to be effective for
just the current window or for all windows.  Each window can have its own color
settings.  Pressing <Esc> cancels any edit window color changes.

Return to the Options menu and press <T> to bring up the "Type of monitor"
submenu.  The first selection, "Color monitor," forces Pas-Ed to treat your
video system as either color or monochrome.  Most of the time, Pas-Ed will




Chapter 2 - Setting Up Pas-Ed                             Pas-Ed Manual - Page 9



accurately detect the type of video system in use and adjust for it.  Some video
systems are not what they appear to Pas-Ed, however, such as a monochrome LCD
display running as a CGA.  Under such circumstances, you may find it necessary
to reset this option.

The second selection, "Suppress snow," is important only if you have an older
CGA system.  Early model CGAs display "snow" during untimed direct screen
writes, which is how Pas-Ed writes to the screen by default.  If you notice snow
on your screen, set this option on.  The resulting screen writes will be
slightly slower but free of snow.

The third selection, "43/50 rows," resets the video mode to 43 screen lines if
you have an EGA system or 50 screen lines for a VGA.  If you don't have one of
these systems, a message to that effect appears and this option can't be
enabled.



Setting Up The Macros


Press <Alt-M> to open the Macros menu.  Macros are on by default.  If you don't
want to use the macros, you can turn macro processing off by pressing <T> for
"Turn on/off."  If you use macros, you may wish to reset the macro playback
delay, which controls the number of milliseconds between keystrokes when a macro
playback is in progress.  The default is 0.



Setting Up The Files


Press <Alt-L> to open the Language menu.  Press <F> to open the "Files" submenu.
The "Files" submenu contains the names of the files Pas-Ed will use during DOS
shells and compile and debug sessions.  You may enter any compiler,
configuration, or debugger file names (of course, they should correctly name an
appropriate program or file), and, as with all menu options, they're saved in
the PAS-ED.CFG configuration file and restored upon startup.  The complete path
name to COMMAND.COM is needed to operate the DOS shell.  Check each of these
options to make sure they're correct, and change them if necessary.



Setting Up Turbo Pascal


Press <Esc> to return to the Language menu.  The first selection on the Language
menu, "Compiler," sets the Turbo Pascal compiler switches.  The second
selection, "Linker," sets the Turbo Pascal linker switches.  The "Directories"
selection determines the directories where Turbo Pascal will look for the
various files it needs during compilation and where the resulting compiled files




Chapter 2 - Setting Up Pas-Ed                            Pas-Ed Manual - Page 10



will be placed.  These options are the same as those in the Turbo IDE, and you
should refer to your Turbo Pascal manuals and Chapter 4 - The Pas-Ed Menu System
if you need further information.



Ready To Go


Pas-Ed is now ready to run.  If you're familiar with the Turbo IDE, you should
be able to run Pas-Ed with little problem.  For an overview of running Pas-Ed,
please read the next chapter, Chapter 3 - A Tour of  Pas-Ed.











































Chapter 2 - Setting Up Pas-Ed                            Pas-Ed Manual - Page 11




                         Chapter 3 - A Tour of Pas-Ed
                         



Getting Ready


This chapter illustrates most of Pas-Ed's main features in tutorial fashion.

If you're in Pas-Ed, make sure the Options/Config Auto Save menu option is on,
then exit Pas-Ed by pressing <Alt-X>.  <Alt-X> works from anywhere in Pas-Ed
except the message windows, which require a specific response such as "Y" or "N"
or <Esc>.  At the DOS prompt, type "Pas-Ed" to restart Pas-Ed.



Restoring Your Setup


Since you've created a PAS-ED.CFG configuration file, Pas-Ed asks whether you
want to restore the previous setup.  Press <Y>, and the File Name window appears
with the name of the first file from your previous setup in it.  You have four
options:

1.   Press <Enter> to load the file.

2.   Press <Esc> to tell Pas-Ed you don't want to load the file.

3.   Edit the name in the File Name window, pressing <Enter> when finished.

4.   Use DOS wildcards (such as "*") to bring up a directory.  ".PAS" is the
     default extension.  You can maneuver around the directory by using either
     the dedicated movement keys or WordStar commands.   If you have a directory
     hierarchy, you can maneuver through the various directories by highlighting
     the appropriate directory and pressing <Enter>.  "..\" indicates the parent
     directory of the current directory.  If a file is highlighted, pressing
     <Enter> opens the highlighted file.  <Esc> clears the Directory window and
     calls the File Name window again.

For now, press <Esc> to tell Pas-Ed you don't want to load the file.  After
you've dealt with the first file, the rest of the files from your previous setup
cycle through the File Name window one by one.  Press <Esc> as each file name
appears so Pas-Ed won't load any of them.  Pas-Ed has to have at least one
window open, so Pas-Ed opens a NONAME file.









Chapter 3 - A Tour of Pas-Ed                             Pas-Ed Manual - Page 12



The Editor


Press <Esc> to enter the editor.  The editor uses the WordStar command set and
is virtually identical to the editor in the Turbo IDE.  Try typing a few lines.
If you forget an editing command, press <F1> to bring up the help window.

One of the most useful and overlooked editing commands is the undo line change
command.  Return to the first line, type some changes, then type <Ctrl-Q><L>
(for Quick-Line).  The line is restored to its original form.  This command
works as long as you haven't erased or moved off the line.

The top line of the edit window shows the state of the editor and is explained
in detail in Chapter 5 - The Pas-Ed Editor.  For now, try pressing the Caps
Lock, Num Lock, and Scroll Lock keys and note how they affect this line.

The status (or bottom) line shows, from left to right, the window number, the
commands associated with the function keys, and the location of the edit buffer
for the active window ("DOS" or "EMS").

Now press <F2> to save the file.  <F2> saves the file regardless of the setting
of the Options/Edit File Save menu option.

Press <F3> to load a new file, and the File Name window appears.  Enter a file
name, and that file is loaded into the current window.  If it's a new file,
Pas-Ed verifies that you actually wanted to create a new file and didn't just
make a typing mistake.

Press <F4> to open a new window.  The File Name window reappears, only this time
the file you specify will be loaded into a new window.  The new window number is
visible in the lower left corner of the screen.  This number always shows the
window number of the file being acted upon.  Enter a file name and the window
will be created and the file loaded.

Press <F5> and the active window is reduced to half screen (unzoomed).  Now
press <F6> several times to rotate between the two windows.  While in the full
screen (zoomed) window, press <F5> to unzoom this window.  One window must
always be zoomed to provide a background for the unzoomed windows, and Pas-Ed
prevents the full screen window from being unzoomed.

Type something and mark a block in each window.  <Ctrl-K><B> marks the beginning
of a block and <Ctrl-K><K> marks the end.  Using the F5 and F6 keys, switch the
windows until both windows and blocks are visible on the screen.  Press
<Ctrl-K><C> to copy the block in the active window to the cursor position.  Now
press <F7> and copy the block from the other window to the cursor position.
Move the cursor a little and press <Ctrl-K><V> to move the block in the active
window to the cursor position.  Now press <F8> and move the block from the other
window to the cursor position.  Note that both <F7> and <F8> work within the
current window as well.  If your printer is connected to the LPT1 parallel
printer port 1 and turned on, use <Ctrl-K><P> to print the block.





Chapter 3 - A Tour of Pas-Ed                             Pas-Ed Manual - Page 13



Type a nonsense word to ensure that the file in the active window can't be
compiled properly.  Press <F9> to make (compile) the file.  Pas-Ed will either
swap a DOS memory image to EMS/disk or compresses the heap depending on the
setting of the Options/Memory Usage submenu, and then call the TPC.EXE compiler
to compile the file.  If you get an out of memory message, change the
Options/Memory Usage/Swap To EMS/Disk setting to on, then recompile the file.
The compiler will find the error, and Pas-Ed will automatically locate the
error, highlight it, and display the error message.  Press <Esc> to clear the
error message.



The Window Menu


Press <Alt-W> to open the Window menu.  Press <H> to hide the active window.
Now press <Alt-E> to return to the editor, then <F6> several times to rotate to
the next active window.  As you can see, the window has indeed been hidden.
Press <Alt-W> to reopen the Window menu, then <U> for Unhide.  A menu appears
with a list of all the hidden windows, and you can either pick one to unhide or
press <Esc> to cancel.  Press <Esc>, then <P> for Pick.  A pick list of all
files appears, with the hidden windows clearly marked as such and the active
window prefaced by "".  The pick list selects a new active window.  Select the
hidden window as the new active window, and it is immediately unhidden and
becomes the active window.

Press <C> for Close, and the active window is closed and removed from memory.
Now try to close the remaining window and Pas-Ed will prevent this.  At least
one window must always be open.  Press <O> and reopen the closed window.

The remaining entries on the Window menu rotate forward and backward through the
file rotation and zoom and unzoom the windows, similarly to the F5 and F6 keys
in the editor.



The Search Menu


Press <Alt-S> to open the Search menu.  This menu enables you to search and move
quickly through the files.  The Find and Replace menu selections are the same as
the <Ctrl-Q><F> (Quick Find) and <Ctrl-Q><A> (Quick Find and Replace) WordStar
commands.  The fiNd next and rePlace next menu selections are the same as
Wordstar's <Ctrl-L>.  The fInd block and rEplace block menu selections load the
search string with up to 30 characters from the marked block in the active
window, although not across line breaks.  Since there's a marked block in the
active window, press <I>, then <E> from the Search menu to try these selections.

From the Search menu, press <G> for Goto line.  Enter a line number and Pas-Ed
jumps to the specified line.  If the line number is greater than the number of
lines in the file, Pas-Ed jumps to the end of the file.




Chapter 3 - A Tour of Pas-Ed                             Pas-Ed Manual - Page 14



Press <Alt-S><S> to set a placemarker.  You have ten placemarkers to chose from,
0-9.  Press <5> to set placemarker 5 (the placemarkers don't have to be set in
any particular order).  Press <Alt-W> to open the Window menu and <N> to rotate
to the next window.  Then press <Alt-S> to open to the Search menu, <J> for Jump
To Placemarker, and then enter <5>.  Pas-Ed will jump to the proper file and
line number.  These commands are also available from the editor.  Press <F6> to
rotate to the other file.  Press <Ctrl-K><1> to set placemarker 1, then jump
back and forth between the two files by pressing <Ctrl-Q><5> and <Ctrl-Q><1>.



The Macro Menu


Press <Alt-M> to open the Macro menu.  Through this menu, Pas-Ed can record and
playback keystrokes.  The macro menu is fairly self-explanatory, and you should
have no trouble using the macros.  For good measure, we'll record, edit, and
delete a macro.

Press <R> to record a macro.  A message appears reminding you how to turn macro
recording off.  Press <Esc> to clear the message, then <Alt-E> to enter the
editor.  Notice the "M" next to the window number in the lower left corner of
the screen, indicating that macro recording is on.  Typing carefully (trust us),
type the letter "c", no more, no less, then press <Alt-F10> to turn macro
recording off.   Pas-Ed asks for a key to associate the macro with.  Enter
<Alt-B>, then enter "Bad Macro" as the name for the macro.

Try out the macro by pressing <Alt-B>.  Instead of inserting "c" into the
window, the Compile menu opens.  To see why, press <Alt-M> to open the Macro
menu, then <E> to edit a macro, and choose "Bad Macro" as the macro to edit.
Press <Enter> to accept the macro name and the Edit Macro window appears with
Bad Macro displayed.  The macro should be shown as "<AltE>c."  As you can see,
all keystrokes after macro recording was turned on were faithfully recorded,
including keystrokes that perhaps we didn't want, such as <Alt-E>.  When we
pressed <Alt-B>, Bad Macro first selected Edit from the main menu with <Alt-E>,
then selected the Compile menu with <c>.  You should edit all macros after
they've been recorded to remove unwanted keystrokes.

While in the Edit Macro window, press the Home and End keys.  Instead of moving
the cursor to the beginning and end of the line, <Home> and <End> are inserted
into the macro.  In order to use these keys to maneuver around the Edit Macro
window, you must use the <Scroll Lock> key to toggle between command and literal
interpretation.  Try out the macro editor, in particular noticing how the
extended keys, such as Home, End, Insert, Delete, Backspace, etc., are handled
depending on whether the editor is in Command or Literal mode.

Be sure you're in Command mode, then either press <Enter> to accept the edited
macro or <Esc> to restore the original macro.  Then press <D> for Delete, and
delete Bad Macro.






Chapter 3 - A Tour of Pas-Ed                             Pas-Ed Manual - Page 15



The Other Menus


The other menus are concerned mostly with setting up and running Pas-Ed and
Turbo Pascal.  The selections are either easily understood by programmers
familiar with Turbo Pascal or are explained in Chapter 2 - Setting Up Pas-Ed,
Chapter 4 - The Pas-Ed Menu System, or in your Turbo Pascal manuals.

One useful option that should be pointed out is the Options/View Last DOS Screen
menu selection.  Press <Alt-O><V>, and the last DOS screen appears.  Pressing
any key clears the screen.  This is especially useful for locating errors when a
compiler other than Turbo Pascal is being used with Pas-Ed, such as when
compiling assembler routines.



The Pop-up Tables


Two of Pas-Ed's handiest features are the pop-up ASCII and extended key code
tables.  Press <Alt-E> to return to the editor.  <Alt-A> brings up the ASCII
table, and <Alt-K> bring up the extended key code tables.

































Chapter 3 - A Tour of Pas-Ed                             Pas-Ed Manual - Page 16




                      Chapter 4 - The Pas-Ed Menu System
                      



About the Menus


Pas-Ed's menus are similar in style to those in the Turbo IDE.  The main menu
displays horizontally across the top row of the screen, with pull-down submenus
opening vertically below.  All selections on the main menu are "hot keyed" and
can be selected from anywhere in Pas-Ed (except from the pop-up message windows)
by holding down the <Alt> key and pressing the first letter of the selection.
For example, to open the File menu, press <Alt-F>, and to select Run, press
<Alt-R>.

Moving around the menu system is accomplished by using either the dedicated
movement keys, such as the arrow, Home, and End keys, or WordStar commands, such
as <Ctrl-S> for left, <Ctrl-D> for right, <Ctrl-E> for up, <Ctrl-X> for down,
etc.  Pressing <Enter> when the light bar is over a selection or pressing its
highlighted letter selects it.  Pressing <Esc> deselects or closes a menu.

To assist you in choosing the proper menu options, each individual selection has
a brief descriptive prompt displayed in the status line.



The Menu Selections


This section describes the operation and function of each menu selection.  The
menu selections are:

File

Displays the File menu.  The File menu selections are:

     Load
     
     Loads a file into the active window.  If the requested file is already
     loaded in another window, you're given the choice of either switching to
     that window or going ahead and loading the file into the active window.
     The file which was already in the window is saved according to the setting
     of its "Edit File Save" toggle (see the Options menu).  This option can be
     selected from within the editor by pressing <F3>.

     Pick
     
     Displays a list of all files loaded in all windows and allows you to select





Chapter 4 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 17



     one as the active window.  This option is identical to the Pick selection
     in the Window menu.

     Clear
     
     Deletes all data from the active window.  You're asked to confirm this
     action before the data is deleted.

     Save
     
     Saves the file in the active window to disk regardless of the setting of
     its Edit File Save toggle.

     save All
     
     Saves all changed files to disk according to the setting of their Edit File
     Save toggles.

     Write to
     
     Writes the file in the active window to a file you specify.

     Dir
     
     Display a directory based on a directory mask you specify.

     OS shell
     
     Runs the DOS command you specify.  If no command is given, the screen is
     cleared and the DOS prompt appears.  Pas-Ed is re-entered by typing "EXIT"
     at the DOS prompt.  If EMS/disk swapping is enabled, the contents of memory
     are swapped out to EMS or disk prior to the DOS shell; otherwise, the heap
     is compressed.

     Exit
     
     Exits Pas-Ed and returns to DOS.  The files being edited are saved
     according to their Edit File Save toggles.  If the Config Auto Save and/or
     Macro Auto Save toggles are on, the configuration and/or macro files are
     saved.  See the Options menu for an explanation of these toggles.


Window

Displays the Window menu.  The Window menu selections are:

     Open
     
     Opens a new edit window if sufficient memory is available.  Windows are
     allocated first in DOS memory, then in EMS memory.  Up to 21 windows may be
     opened.




Chapter 4 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 18



     Close
     
     Closes the active window and deallocates it memory.  If the file in the
     active window has been changed during the editing session, it's saved
     according to the setting of its Edit File Save toggle (see the Options
     menu).

     Pick
     
     Displays a list of all files loaded in the windows and allows you to select
     one as the active window.  This option is identical to the Pick selection
     in the File menu.


     Next
     
     Selects the next unhidden window as the active window.

     Back
     
     Selects the previous unhidden window as the active window.

     Zoom
     
     Resizes the active window to either full or half screen.  Note that at
     least one window must always be full screen to provide a background for the
     unzoomed windows.

     Hide
     
     Hides the active window.  The data in a hidden window remains intact and
     the file save routines aren't affected.  The window is simply removed from
     the window rotation.  This enables you to avoid rotating between an
     excessive number of windows.  For example, you might have 21 windows open
     but only 3 files actively being edited; this options allows you to hide the
     other 18 windows.  Hidden windows may be unhidden with either the Unhide or
     Pick commands.  Note that at least one window must be unhidden.

     Unhide
     
     Displays a list of all hidden windows and allows you to select one to
     unhide.


Edit

Erases the menus, displays the active window, and calls the editor.








Chapter 4 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 19



Search

Displays the Search menu.  The Search menu selections are:

     Find
     
     Finds the search string using the search options you specify.

     fInd block
     
     Loads the search string with up to 30 characters from the marked block in
     the active window.  Characters are not loaded across line breaks.

     fiNd next
     
     Finds the next occurrence of the search string using the previous search
     options.

     Replace
     
     Finds the search string and replaces it with the replacement string using
     the replace options you specify.

     rEplace block
     
     Loads the search string with up to 30 characters from the marked block in
     the active window.  Characters are not loaded across line breaks.

     rePlace next
     
     Finds the next occurrence of the search string and replaces it with the
     replacement string using the previous replace options.

     Goto line
     
     Moves the cursor to the line number you specify.

     Set marker
     
     Sets the placemarker you specify (0 to 9) to the current cursor position in
     the current file.

     Jump to marker
     
     Jumps to the placemarker you specify (0 to 9) as long as the file
     containing the placemarker is in memory.  The jump will be made even if the
     file is in a different window from the window where the placemarker was set
     and even if the window containing the file is hidden.  Jumping into a
     hidden window doesn't unhide it; as soon as you exit the window, it's
     removed again from the window rotation.  If there are 2 windows containing
     the same file, Pas-Ed jumps to the first one.




Chapter 4 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 20



Macros

Displays the Macro menu.  The Macro menu selections are;

     Playback
     
     Plays back the macro you specify.

     Record
     
     Begins recording keystrokes into a macro.

     record Off
     
     Stops recording keystrokes and asks for a key to associate the macro with
     as well as a name for the macro.  This is the same as pressing <Alt-F10>
     from within the editor.  After a macro has been recorded, you should edit
     the macro to remove any keystrokes associated with setting up the macro.
     Pas-Ed automatically removes the keystrokes that turned macro recording
     on and off.

     Load
     
     Loads a macro file, replacing the macros in memory with the macros from the
     file.

     Merge
     
     Merges the macros from a macro file with the macros in memory.  If the
     current macro file is then saved after the merge, it will include the
     merged macros.

     Save
     
     Writes the macros in memory to the current macro file.

     list
     
     Lists the macros in memory.

     Edit
     
     Edits an in-memory macro.

     Delete
     
     Deletes an in-memory macro and deallocate its memory.








Chapter 4 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 21



     delete All
     
     Deletes all in-memory macros and deallocates their memory.  You're asked to
     confirm this action.

     macro delaY
     
     Adjust the delay between keystrokes when a macro is played back.  The delay
     is in milliseconds, and can be any number between 0 and 255.

     Turn on/off
     
     Enables and disables macro processing.  Macro processing is on by default.
     When disabled, all macros are deleted and their memory deallocated.  When
     enabled, the macros in the current macro file are reloaded into memory.


Compile

Displays the Compile menu.  The Compile menu selections are:

     Compile
     
     The selected file is compiled.  No other used units with existing TPU files
     are compiled even if their source code has changed since they were last
     compiled.

     Make
     
     The selected file is compiled along with all units used by the program
     whose source code has changed since they were last compiled.

     Build
     
     The selected file and all units used by the program are compiled.  This
     option ensures that all TPU files are up to date.

     Production build
     
     The selected file and all units used by the program are compiled using your
     regular compiler settings, except no debug information is generated and
     stack and range checking are turned off.  This option ensures that all TPU
     files are up to date.

     Auto config file
     
     Enables and disables the automatic creation of a compiler configuration
     file.  When enabled, an updated compiler configuration file is written to
     disk prior to every compile; if disabled, no configuration file is written.
     The default name for the configuration file is TPC.CFG, which can be
     changed using the Language/Files submenu.




Chapter 4 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 22



     Find error
     
     Locate the source code location of a run-time error if you have its hex
     location.  For example, a runtime range error might result in the message
     "Runtime error 201 at 3C08:023B."  By entering the hex number "3C08:023B"
     as the error location, Pas-Ed will automatically locate and display the
     line in the source code that caused the error.


Run

Run a program from within Pas-Ed.  If EMS/disk swapping is enabled, a DOS memory
image is swapped out to EMS or disk prior to the program run.


Debug

Debug a program from within Pas-Ed.  If EMS/disk swapping is enabled, a DOS
memory image is swapped out to EMS or disk prior to the debug session.


Language

Displays the Language menu.  The Language menu selections are:

     Compiler
     
     Displays the Compiler submenu, which contains the options for the Turbo
     Pascal compiler.  The Compiler submenu selections are:

          Align data
          
          Align variables and typed constants on byte or word boundaries.
          Generally, byte alignment takes less space while word alignment is
          faster.

          Boolean evaluation
          
          Switch between complete and short circuit boolean evaluation, which
          determines whether boolean expressions are evaluated completely or
          terminated as soon as possible.

          Conditional defines
          
          Enter conditional compilation directives which can be referenced in
          the source code.

          Debug information
          
          Displays the Debug menu.  The Debug menu selections are:





Chapter 4 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 23



               Append debug info to EXE
               
               Enables and disables the appending of debug information to the
               compiled EXE file.  This information is necessary to use Turbo
               Debugger on your program.  The extent of the debugging
               information appended depends on the following two settings:

               Make line-number table
               
               Enables and disables the generation of a source code line-number
               table.  This table allows Turbo Debugger to step through the
               source code line by line during a debug session.  Unless this
               option is enabled, Turbo Debugger steps through your program at
               the CPU (assembly) level.

               Include local symbols
               
               Enables and disables the generation of debug information for
               local symbols, which are the names and types of all local (as
               opposed to global) variables and constants.

          Force far calls
          
          Enables and disables the use of the FAR code model by all procedures
          and functions.

          I/O Checking
          
          Enables and disables the generation of code to check for input/output
          errors.

          Memory sizes
          
          Displays the Memory Size submenu.  The selections on the Memory Size
          submenu are:

               Stack size
               
               Set the stack size in decimal bytes.

               Low heap limit
               
               Set the minimum required heap size in decimal bytes.

               High heap limit
               
               Set the maximum heap size in decimal bytes.

          Numeric processing
          
          Displays the Numeric Processing submenu.  The selections are:




Chapter 4 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 24



               Emulation
               
               Enables and disables linking of the 8087 emulation library.  This
               library uses the 8087 math coprocessor if present and emulates it
               if not.

               Numeric processing
               
               Switches between inline 8087 code, which allows the use of
               single, double, extended, and comp real types, or the use of
               software-only (6 byte) reals.

          Overlays allowed
          
          Enables and disables the generation of overlay code.  Units compiled
          with this option do not have to be overlayed.

          Range checking
          
          Enables and disables the generation of code to check the bounds on
          arrays, strings, and scalar-type variables.

          Stack checking
          
          Enables and disables the generation of code to check for stack
          overflow.

          Var-string checking
          
          Enables and disables checking of declared string parameters against
          the actual passed parameter.  If this option is on and the declared
          and actual string parameters are not identical, a compiler error
          occurs.

     Linker
     
     Displays the Linker submenu.  The selections are:

          Link buffer
          
          Switch between using a disk or memory link buffer.  Linking to memory
          is faster but the linker may run out of memory on larger programs.
          Linking to disk is slower but larger programs can be linked.

          Map file
          
          Sets the amount of information that goes into the map file (typically
          used by 3rd party debuggers).  The selections are:







Chapter 4 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 25



               None
               
               No map file is generated.

               Segments
               
               Only segment information is generated.

               Publics
               
               Segment information plus all symbol names and addresses and the
               location of the program's entry point are generated.

               Detailed
               
               Publics information plus line-number and module tables are
               generated.

     Directories
     
     Displays the Directories submenu, which contains the paths to the various
     files needed by the Turbo pascal compiler.  The Directory submenu
     selections are:

          Turbo directory
          
          The compiler will search the current directory and the directory
          specified here for the compiler configuration file and the library
          file.

          EXE & TPU directory
          
          The compiler will put the compiled EXE and TPU files in the directory
          specified here.  If no directory is specified, the compiled files will
          go in the directory with the source code file.

          Include directories
          
          The compiler will search the current directory and the directories
          specified here for the files listed with the Include {$I Filename}
          compiler directive.

          Unit directories
          
          The compiler will search the current directory and the directories
          specified here for units used by the files being compiled.

          Object directories
          
          The compiler will search the current directory and the directories





Chapter 4 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 26



          specified here for the object files listed with the {$L Filename}
          compiler directive.

     Files
     
     Displays the Files submenu, which contains the names of the various files
     called by Pas-Ed during operation.  The Files submenu selections are:

          Compiler file name
          
          The file Pas-Ed will call to compile files.  ".EXE" is the default
          extension.

          conFigure file name
          
          The compiler configuration file.  This is the file Pas-Ed will write
          the Turbo Pascal compiler and linker switches to if the Auto Config
          File option is enabled (see the Compile menu).  ".CFG" is the default
          extension.

          Debugger file name
          
          The file Pas-Ed will call to debug files.  ".EXE" is the default
          extension.

          COMMAND.COM
          
          The complete path to COMMAND.COM, which is necessary for proper
          operation of the DOS shell.


Options

Displays the Options menu.  The Options menu selections are:

     Config auto save
     
     Enables and disables automatic saving of the PAS-ED.CFG configuration file
     upon exit.  At startup, Pas-Ed looks in the current directory for the
     configuration file, which contains a description of Pas-Ed's last setup.
     Using this information, Pas-Ed can restore the last setup.

     Edit file save
     
     Switches between automatic, prompted, and no file saves.  If set to Auto,
     the file will be automatically saved if it has been changed during the
     editing session.  If set to Prompt, you're prompted whether or not to save
     the file.  If set to Off, the file is not saved and you're not prompted.
     You're given the choice of applying the new setting to just the active
     window or to all windows.





Chapter 4 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 27



     Backup files
     
     Enables and disables the creation of backup files.  You're given the choice
     of applying the new setting to just the active window or to all windows.

     Macro auto save
     
     Enables and disables automatic saving of the macro file before exit.

     Write config file
     
     Writes the Pas-Ed configuration file PAS-ED.CFG to disk using the current
     settings.

     memory Usage
     
     Displays the Memory Usage submenu.  The selections are:

          Swap to EMS/Disk
          
          Enables and disables the swapping of a DOS memory image to expanded
          memory (EMS) or disk prior to a DOS shell or compile, debug, or run
          session.  If enabled, more memory is freed up than would otherwise be
          available; however, this must be balanced against the time penalty
          imposed by the swap.  On systems with EMS memory, the time penalty is
          minimal and this option can be left enabled.  Systems requiring disk
          swaps, and in particular swaps to a floppy disk,  might want to
          disable this option during simple DOS shells, providing enough DOS
          memory is available for the exec session.

          Reserve EMS for swap
          
          Enables and disables the reservation of enough EMS memory to hold a
          DOS memory swap.  If enabled, enough 16k (16,384 byte) blocks of EMS
          memory are set aside for the swap.

          Working memory
          
          Sets the amount of DOS memory reserved by Pas-Ed for internal purposes
          such as screen saves, macros, EMS-to-EMS block moves, etc.  By
          adjusting this value, sufficient memory can be reserved to allow
          proper functioning of the program while leaving as much memory as
          possible for the edit buffers.  The default value is 16,384 bytes
          (16k), and may be changed to any value between 16384 and 65535.  The
          default value reserves enough memory to run the program under most
          circumstances.

          If you encounter out of memory messages, simply increase this number.
          Since there's no painless way for the program to recover memory
          already allocated, the program should be exited and restarted if reset
          to a higher value.




Chapter 4 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 28



          DOS buffers open
          
          Displays the number of edit windows opened in DOS memory.

          EMS buffers open
          
          Displays the number of edit windows opened in EMS memory.

          Total buffers open
          
          Displays the total number of open windows.

          EMS/Disk Swap Size
          
          Displays the exact size in bytes of the DOS memory swap.

          EMS reserved for swap
          
          Displays the amount of expanded memory (EMS) reserved for the DOS
          memory swap.  Since EMS memory is allocated in 16k (16,384 byte)
          blocks, this figure is almost always larger than the exact size of the
          DOS memory swap file.

          Edit buffer size
          
          Displays the size in bytes of the edit buffers (all buffers are the
          same size).

     Screen colors
     
     Displays the Screen Colors submenu, which allows you to change the screen
     colors.  The functioning of the Screen Colors submenu is explained in
     detail in Chapter 2 - Setting Up Pas-Ed.

     The types of screen colors fall into 5 general categories:

          Text colors
          
          There are four text color types: Normal, Highlighted, Marked Block,
          and Error, which are the colors used when displaying the editing
          windows.  Normal is the regular text color, Highlighted is for the
          message line, Marked Block for marked blocks, and Error for error
          messages.

          General screen colors
          
          There are two general screen color types: Screen Background and Status
          Line.  Screen Background is used when not in the editor or menu
          system, such as during DOS shells, compiles, etc.  Status Line is used
          for the bottom row of the screen.





Chapter 4 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 29



          Menu colors
          
          There are five menu color types: Normal, Highlighted, Selected,
          Border, and Title.  Normal is the regular menu color, Highlighted is
          for selection letters, Selected for the moving light bar, Border for
          the menu border, and Title for menu headers.

          Message colors
          
          The five message color types are essentially the same as the five menu
          colors types except they're used to display general messages.

          Help colors
          
          The five help color types are basically the same as the five menu
          colors types except they're used to display help messages.

     Default screen colors
     
     Resets the screen colors to their default values.  You're asked to confirm
     this selection.  You have the choice of restoring the default colors in
     just the active window or in all windows.  No window colors are changed if
     <Esc> is pressed.

     Type of monitor
     
     Displays the Monitor submenu.  The selections are:

          Color monitor
          
          Forces Pas-Ed to treat your video display as either color or
          monochrome.

          Suppress snow
          
          Suppresses snow on older CGA displays at the expense of somewhat
          slower screen writes.

          43/50 rows
          
          Allows EGA/VGA systems to display 43/50 screen rows respectively.  The
          default is 25 rows.













Chapter 4 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 30




                         Chapter 5 - The Pas-Ed Editor
                         



About the Editor


Turbo Pascal programmers should have little trouble adapting to Pas-Ed's editor,
as it uses the same command set as the Turbo IDE.  Pas-Ed's windows operate much
like Sidekick's, and on-line help is available through the <F1> key.

Because of the editor's similarity to the Turbo IDE editor and since Pas-Ed
users are assumed to be familiar with Turbo Pascal and to have the Turbo Pascal
manuals, the description of the editor is brief.



The Editor Message Line




      Line 1    Col 1   Insert Indent Tab D:TESTFILE.PAS  Scr Num CAP BAK Auto




Above is an example of the editor message line, which appears at the top of each
text window and shows the status of the editor for that particular window.  Each
window can have different settings except for the keyboard status toggles, which
are the same in all windows.  The message line entries are:

     Line             The line number on which the cursor is located.

     Col              The column number in which the cursor is located.

     Insert           If visible, indicates that characters are being inserted
                      into the text buffer.  If off, characters are overwriting
                      the existing text.  This option is toggled by <Ctrl-V> or
                      <Insert>.

     Indent           If visible, indicates that new lines are indented to the
                      level of the line above.  If off, new lines start at
                      Column 1.  This option is toggled by <Ctrl-Q><I>.

     Tab              If visible, indicates that fixed, 8-column tabs are
                      enabled.  If off, tabs are set at the first letter of the
                      words on the line above.  This option is toggled by
                      <Ctrl-O><T>.




Chapter 5 - The Pas-Ed Editor                            Pas-Ed Manual - Page 31



     D:TESTFILE.PAS   The name of the file being edited.  Note that the full
                      path name is not displayed.

     Scr              If visible, indicates that the Scroll Lock key is on.

     Num              If visible, indicates that the Num Lock key is on.

     CAP              If visible, indicates that the Caps Lock key is on.

     BAK              If visible, indicates that a backup file will be made when
                      the file in the active window is saved.

     Auto             Displays the status of the Options/Edit File Save menu
                      option.  If "Auto" is displayed, then the file in the
                      active window will automatically be saved.  "Prompt" means
                      you'll be prompted whether or not to save the file, and no
                      display means the file won't be saved and you won't be
                      prompted.



The Editor Status Line




2M   F1Help F2Save F3Load F4Open F5Zoom F6Next F7Copy F8Move F9Make F10Menu  DOS




Above is an example of the editor status line.  From left to right, the "2"
indicates that the number 2 edit window is active.  The "M" next to the "2"
means that macro recording is on.  In the middle are the function keys along
with a keyword description of their function.  The "DOS" on the far right
indicates that the active window has been allocated in DOS memory.  If the
active window had been allocated in EMS memory, "EMS" would be displayed.



The Function Keys


The functions assigned to the function keys are:

     <F1> - Help.
            Displays a help menu, from which various help windows can be
            displayed showing the various editing commands.

     <F2> - Save.
            Saves the file in the active window to disk.




Chapter 5 - The Pas-Ed Editor                            Pas-Ed Manual - Page 32



     <F3> - Load.
            Loads a new file into the active window.

     <F4> - Open.
            Opens a new edit window if enough memory is available.

     <F5> - Zoom.
            Resizes the active window to full or half screen.

     <F6> - Next.
            Selects the next open window as the active window.

     <F7> - Copy.
            Displays a pop-up menu showing the files with marked blocks.  The
            block from the selected file is copied into the active window at the
            cursor location.  This option is identical to the <Ctrl-K><C> block
            copy command except that it can also copy between files.

     <F8> - Move.
            Displays a pop-up menu showing the files with marked blocks.  The
            block from the selected file is moved into the active window at the
            cursor location.  This option is identical to the <Ctrl-K><V> block
            move command except that it can also move between files.

     <F9> - Make.
            Makes (compiles) the file in the active window.

     <F10> - Menu.
             Opens the menu system.  This option is the same as <Alt-E>.


Entering Text


Text is entered into the Pas-Ed editor in a fashion similar to the Turbo IDE.
Like the IDE, Pas-Ed doesn't wrap lines, and lines must be terminated with
<Enter>.  As long as the cursor hasn't been moved from the line being edited and
the line hasn't been erased, the original line can be restored with <Ctrl-Q><L>.
If the Insert toggle is on, characters are inserted into the text buffer;
otherwise, characters overwrite the existing text.

The Pas-Ed editor is a WordStar command editor, and is virtually identical to
the editor in the Turbo IDE.  The Turbo Pascal manuals have a good explanation
of the editing commands.  If you need a quick reference of the commands, press
<F1> from within the editor to bring up the help menu.  If you need a quick
reference of ASCII or extended key codes, press <Alt-A> for a pop-up ASCII table
and <Alt-K> for an extended key code table.








Chapter 5 - The Pas-Ed Editor                            Pas-Ed Manual - Page 33




                       Chapter 6 - Hints On Using Pas-Ed
                       



Hint:   Pas-Ed's text buffers are completely independent of one another.  If
        you've loaded the same file into two windows, remember that you aren't
        editing the same text in two windows but rather are editing two separate
        text buffers. Changes made to the text in one window aren't being made
        to the text in the other window.  If you make different changes in each
        window and save both windows, the file on disk will contain the changes
        made in the last window saved.


Hint:   When working on multi-file programs, always load the main program into
        the same window in the file rotation.  That way, you can compile the
        program from any window by using a macro which switches to that window
        and compiles the file.  For example, we always load the main program in
        the first (number 1) window, which is then always selection "A" on the
        Window/Pick submenu.  We use the following macro to make (compile) the
        file:

        <AltW>pa<AltC>m<Enter>

        This macro opens the Window menu, selects the Pick option, selects the A
        window (Window 1), opens the Compile menu, selects Make, and starts the
        compile.


Hint:   Although you can write macros which operate across DOS shells and
        compile, debug, and run sessions, it's usually best not to write these
        macros unless you're absolutely sure in advance of the results of the
        session.  For example, at the end of a compile, Pas-Ed always displays a
        message indicating the results of the compile.  If you write a macro
        that automatically clears this message, you'll lose any error messages
        should an error occur, and you'll have to manually examine the error
        message using the Options/View Last DOS Screen menu option


Hint:   If you're using a compiler other than Turbo Pascal, use the Options/View
        Last DOS Screen menu option to view compiler messages.


Hint:   Be careful when running the DOS shell.  After shelling to DOS and
        running another program or two and/or several DOS commands, it's easy to
        forget that you're still running DOS from within Pas-Ed's DOS shell.
        Starting or unloading a TSR or certain other programs at this point can
        crash your system.

        This is also a common way source, macro, and configuration files get




Chapter 6 - Hints On Using Pas-Ed                        Pas-Ed Manual - Page 34



        jumbled.  Say you've shelled to DOS, then forgotten you're in the DOS
        shell and restarted Pas-Ed.  You then edit files, change macros and menu
        settings, and exit Pas-Ed.  You later realize you're still in the
        original DOS shell and type "EXIT" at the DOS prompt and re-enter the
        original Pas-Ed, which then swaps back into memory ALL THE OLD FILES,
        MACROS, AND MENU SETTINGS.  If you exit Pas-Ed at this point without
        making sure the edit, macro, and configuration file auto save options
        are turned off, your new changes will be overwritten by the old files
        and settings.  Plus if the backup file option is turned off, there's no
        backup copy of your source files to restore your new editing changes.
        This is one good reason to leave the backup file option on.


Hint:   If your keyboard locks up, try holding down the <Ctrl> key and
        alternately pressing the left and right shift keys several times.  This
        will sometimes (not often) unlock the keyboard.  When trying to trace
        the source of the problem, first check to be sure it wasn't caused by
        the program you're writing.  If the problem persists, it may be a
        conflict between Pas-Ed's macro processor and another program, such as a
        TSR.  To check this, turn macro processing off using the Macros/Turn
        On/Off menu selection.  Pas-Ed is otherwise a plain vanilla program, so
        if the problem continues after macro processing has been turned off,
        it's probably somewhere else.  Try unloading your TSRs one by one to see
        if you can find the problem program.

        If your keyboard locks up during a DOS shell or a compile, debug, or run
        session, then the problem isn't Pas-Ed's macro processor, as it's
        disabled during these sessions.  As an aside, we regularly use Pas-Ed
        with SidekickPlus and have had no problems.


Hint:   If you run out of memory when doing an EMS-to-EMS block copy or move,
        first write the block to a nonsense file, such as TEMP.PAS, using
        <Ctrl-K><W>, then read TEMP.PAS into the destination file using
        <Ctrl-K><R>.  Since only one EMS-based file can be mapped into DOS
        memory at once, EMS-to-EMS block transfers are temporarily allocated in
        working memory.  Failure of these transfers may indicate that the amount
        of working DOS memory reserved by Pas-Ed needs to be increased using the
        Options/Memory Usage/Working Memory menu option.


Hint:   On a related note, remember if you encounter out of memory messages to
        raise the amount of working memory reserved for Pas-Ed using the
        Options/Memory Usage/Working Memory menu option.


Hint:   If your computer doesn't have EMS memory and you have only one or two
        windows open, turn the Options/Swap To EMS/Disk menu option off for
        simple DOS shells or when compiling very small programs, etc.  When
        EMS/Disk swapping is disabled, the heap is compressed for the exec
        session, and enough DOS memory for simple operations should be available




Chapter 6 - Hints On Using Pas-Ed                        Pas-Ed Manual - Page 35



        providing you have only one or, at most, two windows open.  This is very
        much faster than a disk-based DOS memory swap.  If you receive out of
        memory messages, then turn this option off, or, if you have two windows
        open, close one window.


Hint:   The ability to reset colors to their default values can be a lifesaver
        if some jokester in your office has changed all the colors to, for
        example, black on black, making the screen appear completely blank.
        Simply type <N> and then <Esc> a few times in case you've been left
        buried somewhere in the menu system in a pop-up message window, such as
        the message window asking if you want to exit the program.  Then type
        <Alt-O><D><Y> to reset the colors to their defaults.


Hint:   If you want to return to your current setup next time Pas-Ed is started
        but you have another project to work on before exiting Pas-Ed, use the
        Options/Write Config File menu option to immediately write the
        PAS-ED.CFG configuration file to disk.  Then turn the Config Auto Save
        option off to ensure that Pas-Ed won't save your new setup upon exit.
        When you restart Pas-Ed, your current setup will be restored.


Hint:   Remember that <Alt-A> calls up the pop-up ASCII table, and <Alt-K> calls
        up the extended key code table.


Hint:   If you have a hint that others might find useful and you wouldn't mind
        sharing, please sent it to Hedco so it can be included in the next
        version of the manual.

























Chapter 6 - Hints On Using Pas-Ed                        Pas-Ed Manual - Page 36

